using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

//using LTMMLib;
using Leadtools.Multimedia;
using Leadtools.Multimedia.Common;
using LMVCallbackLib;
using Leadtools;

namespace WindowsApplication1
{
    public partial class Form1 : Form
    {
        private LMVMyUserCallback lmvMyUserCallback;
        private LMVCallback lmvCallback;

        private string TARGET_FILE = Application.StartupPath + @"capture.mpg";
        PlayCtrl playctrl;

        public Form1()
        {
            InitializeComponent();

            //***************************************************************************************
            // Uncomment & modify this code accordintly for removing the NAG dialogs & watermarks
            //***************************************************************************************
            //string pszMMKey = "";
            //string pszFilterKey = "";
            //string pszAppID = "Test App";
            //MultimediaSupport.UnlockModule(pszMMKey, LockType.Application, pszAppID);
            //MultimediaSupport.UnlockModule(pszFilterKey, LockType.ApplicationPath, Application.StartupPath + @"\WindowsApplication1.exe");
            //in version 19 we have to set our license even for evaluation, this is default eval path, replace with your license accordingly
            RasterSupport.SetLicense(@"C:\Leadtools 19\Common\License\LEADTOOLS.LIC",
                System.IO.File.ReadAllText(@"C:\Leadtools 19\Common\License\LEADTOOLS.LIC.KEY"));
            //create our playctrl programmatically and set it
            playctrl = new PlayCtrl();
            playctrl.ScaleLeft = 0;
            playctrl.ScaleHeight = 400;
            playctrl.Top = 0;
            playctrl.ScaleWidth = 550;
            playctrl.Location = new Point(16, 71);
            playctrl.Visible = true;
            playctrl.Width = 550;
            playctrl.Height = 400;
            Controls.Add(playctrl);
            btnSnapshot.Enabled = btnStart.Enabled = btnStop.Enabled = false;
 
        }

       

        private bool InsertCallbackFilter()
        {
            bool bRet = false;
            try
            {
                //The string below is retrieved from the LTMM DirectShow Filters List utility
                //The utility is available under "Leadtools Multimedia 19" -> "Processing" -> "Filters"
                //string videoProcessorName = @"@device:sw:{E526D606-22E7-494C-B81E-AC0A94BFE603}\{E2B7DDB0-38C5-11D5-91F6-00104BDB8FF9}";
                //int nIndex = captureCtrl1.VideoProcessors.Find(videoProcessorName);
                //captureCtrl1.SelectedVideoProcessors.Add(captureCtrl1.VideoProcessors.Item(nIndex), 0);
                //lmvCallback = (LMVCallback)captureCtrl1.GetSubObject((int)ltmmCapture_Object.ltmmCapture_Object_SelVideoProcessor);
                Processor videoCallback = playctrl.VideoProcessors.Callback;
                playctrl.SelectedVideoProcessors.Add(videoCallback);
                lmvCallback = (LMVCallback)playctrl.GetSubObject(PlayObject.SelVideoProcessor);

                lmvMyUserCallback = new LMVMyUserCallback();
                lmvCallback.ReceiveProcObj = lmvMyUserCallback;

                lmvMyUserCallback.SnapshotCount = 0;
                bRet = true;
            }
            catch (Exception addFilterException)
            {
                MessageBox.Show("An error has occured in adding the filter\n\n" + addFilterException.Message);
            }

            return bRet;
        }

        private void Form1_Load(object sender, EventArgs e)
        {

            // set up the callback filter
            if (!InsertCallbackFilter())
            {
                MessageBox.Show("Could not add Callback filter");
            }

        }



        private void btnStart_Click(object sender, EventArgs e)
        {
            playctrl.Run();
        }

        //take a snapshot
        private void btnSnapshot_Click(object sender, EventArgs e)
        {
            lmvMyUserCallback.TakeSnapshot = true;
        }

        //stop playback
        private void btnStop_Click(object sender, EventArgs e)
        {
            playctrl.Stop();
        }

        private void fileSelectButton_Click(object sender, EventArgs e)
        {
            
            using (OpenFileDialog dlg = new OpenFileDialog())
            {
                dlg.Filter = "mpg files (*.mpg)|*.mpg";
                if(dlg.ShowDialog() == DialogResult.OK)
                {
                    btnSnapshot.Enabled = btnStart.Enabled = btnStop.Enabled = true;
                    playctrl.SourceFile = dlg.FileName;
                }
            }
        }
    }
}